osmium::memory::Item Class Reference

`#include <item.hpp>`

Inheritance diagram for osmium::memory::Item:
[legend]
Collaboration diagram for osmium::memory::Item:
[legend]

## Public Member Functions

unsigned char * | next () noexcept
const unsigned char * | next () const noexcept
item_size_type | byte_size () const noexcept
item_size_type | padded_size () const
item_type | type () const noexcept
bool | removed () const noexcept
void | set_removed (bool removed) noexcept

## Protected Member Functions

| Item (item_size_type size=0, item_type type=item_type()) noexcept
| Item (const Item &)=delete
| Item (Item &&)=delete
Item & | operator= (const Item &)=delete
Item & | operator= (Item &&)=delete
Item & | set_type (const item_type item_type) noexcept

## Private Member Functions

Item & | add_size (const item_size_type size) noexcept

## Private Attributes

item_size_type | m_size
item_type | m_type
uint16_t | m_removed: 1
uint16_t | m_padding: 15

## Friends

template<typename TMember >
class | CollectionIterator
template<typename TMember >
class | ItemIterator
class | osmium::builder::Builder

## Constructor & Destructor Documentation

osmium::memory::Item::Item | ( | item_size_type | size = `0`,
|  | item_type | type = `item_type()`
| ) |  |

inline explicit protected noexcept

osmium::memory::Item::Item | ( | const Item & |  | ) |

protected delete

osmium::memory::Item::Item | ( | Item && |  | ) |

protected delete

## Member Function Documentation

Item& osmium::memory::Item::add_size | ( | const item_size_type | size | ) |

inline private noexcept

item_size_type osmium::memory::Item::byte_size | ( |  | ) | const

inline noexcept

unsigned char* osmium::memory::Item::next | ( |  | ) |

inline noexcept

const unsigned char* osmium::memory::Item::next | ( |  | ) | const

inline noexcept

Item& osmium::memory::Item::operator= | ( | const Item & |  | ) |

protected delete

Item& osmium::memory::Item::operator= | ( | Item && |  | ) |

protected delete

item_size_type osmium::memory::Item::padded_size | ( |  | ) | const

inline

bool osmium::memory::Item::removed | ( |  | ) | const

inline noexcept

void osmium::memory::Item::set_removed | ( | bool | removed | ) |

inline noexcept

Item& osmium::memory::Item::set_type | ( | const item_type | item_type | ) |

inline protected noexcept

item_type osmium::memory::Item::type | ( |  | ) | const

inline noexcept

## Friends And Related Function Documentation

template<typename TMember >

friend class CollectionIterator

friend

template<typename TMember >

friend class ItemIterator

friend

friend class osmium::builder::Builder

friend

## Member Data Documentation

uint16_t osmium::memory::Item::m_padding

private

uint16_t osmium::memory::Item::m_removed

private

item_size_type osmium::memory::Item::m_size

private

item_type osmium::memory::Item::m_type

private

The documentation for this class was generated from the following file:

- osmium/memory/item.hpp